PipeWire: List

PipeWire 1.6.5

Loading...
Searching...
No Matches
List
SPA » Utilities

Doubly linked list data structure. More...

## Files
file | list.h
| spa/utils/list.h

## Data Structures
struct | spa_list

## Macros
#define | SPA_LIST_INIT(list)
#define | spa_list_is_empty(l)
#define | spa_list_first(head, type, member)
#define | spa_list_last(head, type, member)
#define | spa_list_append(list, item)
#define | spa_list_prepend(list, item)
#define | spa_list_is_end(pos, head, member)
#define | spa_list_next(pos, member)
#define | spa_list_prev(pos, member)
#define | spa_list_consume(pos, head, member)
#define | spa_list_for_each_next(pos, head, curr, member)
#define | spa_list_for_each_prev(pos, head, curr, member)
#define | spa_list_for_each(pos, head, member)
#define | spa_list_for_each_reverse(pos, head, member)
#define | spa_list_for_each_safe_next(pos, tmp, head, curr, member)
#define | spa_list_for_each_safe_prev(pos, tmp, head, curr, member)
#define | spa_list_for_each_safe(pos, tmp, head, member)
#define | spa_list_for_each_safe_reverse(pos, tmp, head, member)
#define | spa_list_cursor_start(cursor, head, member)
#define | spa_list_for_each_cursor(pos, cursor, head, member)
#define | spa_list_cursor_end(cursor, member)

## Functions
SPA_API_LIST void | spa_list_init (struct spa_list *list)
SPA_API_LIST int | spa_list_is_initialized (struct spa_list *list)
SPA_API_LIST void | spa_list_insert (struct spa_list *list, struct spa_list *elem)
SPA_API_LIST void | spa_list_insert_list (struct spa_list *list, struct spa_list *other)
SPA_API_LIST void | spa_list_remove (struct spa_list *elem)

## Detailed Description

Doubly linked list data structure.

## Macro Definition Documentation

## ◆ SPA_LIST_INIT

#define SPA_LIST_INIT | ( |  | list | ) |

Value:
((struct spa_list){ (list), (list) })
spa_list
Definition list.h:39

## ◆ spa_list_is_empty

#define spa_list_is_empty | ( |  | l | ) |

Value:
((l)->next == (l))

Examples
  export-source.c.

## ◆ spa_list_first

#define spa_list_first | ( |  | head,
|  |  | type,
|  |  | member )

Value:
SPA_CONTAINER_OF((head)->next, type, member)
SPA_CONTAINER_OF
#define SPA_CONTAINER_OF(p, t, m)
Definition defs.h:235

Examples
  export-source.c.

## ◆ spa_list_last

#define spa_list_last | ( |  | head,
|  |  | type,
|  |  | member )

Value:
SPA_CONTAINER_OF((head)->prev, type, member)

## ◆ spa_list_append

#define spa_list_append | ( |  | list,
|  |  | item )

Value:
spa_list_insert((list)->prev, item)
spa_list_insert
SPA_API_LIST void spa_list_insert(struct spa_list *list, struct spa_list *elem)
Definition list.h:59

Examples
  bluez-session.c, and export-source.c.

## ◆ spa_list_prepend

#define spa_list_prepend | ( |  | list,
|  |  | item )

Value:
spa_list_insert(list, item)

## ◆ spa_list_is_end

#define spa_list_is_end | ( |  | pos,
|  |  | head,
|  |  | member )

Value:
(&(pos)->member == (head))

## ◆ spa_list_next

#define spa_list_next | ( |  | pos,
|  |  | member )

Value:
SPA_CONTAINER_OF((pos)->member.next, __typeof__(*(pos)), member)

## ◆ spa_list_prev

#define spa_list_prev | ( |  | pos,
|  |  | member )

Value:
SPA_CONTAINER_OF((pos)->member.prev, __typeof__(*(pos)), member)

## ◆ spa_list_consume

#define spa_list_consume | ( |  | pos,
|  |  | head,
|  |  | member )

## ◆ spa_list_for_each_next

#define spa_list_for_each_next | ( |  | pos,
|  |  | head,
|  |  | curr,
|  |  | member )

## ◆ spa_list_for_each_prev

#define spa_list_for_each_prev | ( |  | pos,
|  |  | head,
|  |  | curr,
|  |  | member )

## ◆ spa_list_for_each

#define spa_list_for_each | ( |  | pos,
|  |  | head,
|  |  | member )

Value:
spa_list_for_each_next(pos, head, head, member)
spa_list_for_each_next
#define spa_list_for_each_next(pos, head, curr, member)
Definition list.h:109

Examples
  bluez-session.c.

## ◆ spa_list_for_each_reverse

#define spa_list_for_each_reverse | ( |  | pos,
|  |  | head,
|  |  | member )

Value:
spa_list_for_each_prev(pos, head, head, member)
spa_list_for_each_prev
#define spa_list_for_each_prev(pos, head, curr, member)
Definition list.h:114

## ◆ spa_list_for_each_safe_next

#define spa_list_for_each_safe_next | ( |  | pos,
|  |  | tmp,
|  |  | head,
|  |  | curr,
|  |  | member )

## ◆ spa_list_for_each_safe_prev

#define spa_list_for_each_safe_prev | ( |  | pos,
|  |  | tmp,
|  |  | head,
|  |  | curr,
|  |  | member )

## ◆ spa_list_for_each_safe

#define spa_list_for_each_safe | ( |  | pos,
|  |  | tmp,
|  |  | head,
|  |  | member )

Value:
spa_list_for_each_safe_next(pos, tmp, head, head, member)
spa_list_for_each_safe_next
#define spa_list_for_each_safe_next(pos, tmp, head, curr, member)
Definition list.h:125

## ◆ spa_list_for_each_safe_reverse

#define spa_list_for_each_safe_reverse | ( |  | pos,
|  |  | tmp,
|  |  | head,
|  |  | member )

Value:
spa_list_for_each_safe_prev(pos, tmp, head, head, member)
spa_list_for_each_safe_prev
#define spa_list_for_each_safe_prev(pos, tmp, head, curr, member)
Definition list.h:131

## ◆ spa_list_cursor_start

#define spa_list_cursor_start | ( |  | cursor,
|  |  | head,
|  |  | member )

Value:
spa_list_prepend(head, &(cursor).member)
spa_list_prepend
#define spa_list_prepend(list, item)
Definition list.h:92

## ◆ spa_list_for_each_cursor

#define spa_list_for_each_cursor | ( |  | pos,
|  |  | cursor,
|  |  | head,
|  |  | member )

## ◆ spa_list_cursor_end

#define spa_list_cursor_end | ( |  | cursor,
|  |  | member )

Value:
spa_list_remove(&(cursor).member)
spa_list_remove
SPA_API_LIST void spa_list_remove(struct spa_list *elem)
Definition list.h:77

## Function Documentation

## ◆ spa_list_init()

SPA_API_LIST void spa_list_init | ( | struct spa_list * | list | ) |

Examples
  bluez-session.c, and export-source.c.

## ◆ spa_list_is_initialized()

SPA_API_LIST int spa_list_is_initialized | ( | struct spa_list * | list | ) |

## ◆ spa_list_insert()

SPA_API_LIST void spa_list_insert | ( | struct spa_list * | list,
|  | struct spa_list * | elem )

## ◆ spa_list_insert_list()

SPA_API_LIST void spa_list_insert_list | ( | struct spa_list * | list,
|  | struct spa_list * | other )

## ◆ spa_list_remove()

SPA_API_LIST void spa_list_remove | ( | struct spa_list * | elem | ) |

Examples
  bluez-session.c, and export-source.c.